function shdel__shiftDelete() {
  shdel__debug("func START");
    
  try {
    var myPrefs = shdel__getMyPrefs();
    
    if (myPrefs == null) {
      shdel__debug("no myprefs!");
      return;
    }
    
    state = shdel__getCharPref(myPrefs, "key_state", "disable");
    shdel__debug("state=" + state);
    
    switch(state) {
    case "disable":
      shdel__debug("in disabled state");
      return;
	
    case "shift-delete":
      shdel__debug("in shift-delete state");
      goDoCommand("cmd_shiftDelete");
      return;
	
    case "delete":
      shdel__debug("in delete state");
      goDoCommand("cmd_delete");
      return;
    }
    
    // smart:
    var smartMsgNum = shdel__getIntPref(myPrefs, "smart_silent_del", -1);
    shdel__debug("smartMsgNum=" + smartMsgNum);
    var selectedAmount = shdel__get_selected_msgs_amount();
    if (smartMsgNum >= 0 && selectedAmount > smartMsgNum) {
      shdel__debug("smart: WARN");
      shdel__showCONFIRM(selectedAmount);
      //       if(confirm("Really purge " + selectedAmount + " messages ?"))
      // 	goDoCommand("cmd_shiftDelete");
    }
    else {
      shdel__debug("smart: SILENT SH-del:");
      goDoCommand("cmd_shiftDelete");
    }
  } catch (e) {
    shdel__debug("!!!!shdel__shiftDelete: " + e);
  }
}

function shdel__get_selected_msgs_amount() {
  try {
    var tree = document.getElementById("threadTree");
    var rangeCount = tree.view.selection.getRangeCount();
    var count = 0;
    for(var i=0; i<rangeCount; i++) {
      var start = {};
      var end = {};
      tree.view.selection.getRangeAt(i,start,end);
      
      for(var c=start.value; c<=end.value; c++) {
	++count;
      }
    }    
    
    shdel__debug("count= " + count);
    return count;

  } catch (e) {
    shdel__debug("!!!!!!: " + e);
  }
}

function shdel__showCONFIRM(selectedCount) {
  shdel__debug("showCONFIRM");
  try {
    var params = [selectedCount, false];
    openDialog("chrome://shiftdel_control/content/question_dialog.xul", "showmore",
	       "chrome,modal,centerscreen", params);
    shdel__debug("showCONFIRM params=" + params);
    if (params[1]) 
      goDoCommand("cmd_shiftDelete");
  } catch(e) {
    shdel__debug("showCONFIRM::E:" + e + "\n");
  }
  shdel__debug("showCONFIRM DONE");
}


function shdel__QD_Init() {
  shdel__debug("shdel__QD_Init");
  try {
    var msgnum_gui = document.getElementById("shdel__QD__lbl_messages");
    var selectedAmount = window.arguments[0][0];
    shdel__debug("shdel__QD_Init: selectedAmount=" + selectedAmount);
    msgnum_gui.setAttribute("value", selectedAmount);
    
    var gDialog = document.firstChild;
    gDialog.getButton('cancel').setAttribute('default','true');
    gDialog.getButton('accept').removeAttribute('default'); 
  } catch (e) {
    shdel__debug("shdel__QD_Init E!:" + e + "\n");
  }
  shdel__debug("shdel__QD_Init DONE");
}

function shdel__QD_Yes() {
  shdel__debug("shdel__QD_YES");
  try {
    shdel__debug("shdel__QD_YES1: " + window.arguments);
    window.arguments[0][1] = true;
    //     goDoCommand("cmd_shiftDelete");
    shdel__debug("shdel__QD_YES2: " + window.arguments);
  } catch (e) {
    shdel__debug("shdel__QD_YES E!:" + e + "\n");
  }
  shdel__debug("shdel__QD_YES DONE");
  //   return true;
}


shdel__debug("loaded ok: state=" + shdel__getCharPref(shdel__getMyPrefs(), "key_state", "WRONGDEF"));
